SystemOrganization addCategory: #PQTestJsonRPC!

Object subclass: #ArithArg
	instanceVariableNames: 'A B'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PQTestJsonRPC'!

!ArithArg methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 23:56'!
a
	^ A! !

!ArithArg methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 23:56'!
a: anObject
	A := anObject! !

!ArithArg methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 23:56'!
b
	^ B! !

!ArithArg methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 23:56'!
b: anObject
	B := anObject! !

Object subclass: #PQJsonRPCReq
	instanceVariableNames: 'jsonrpc method params id'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PQTestJsonRPC'!

PQJsonRPCReq class
	instanceVariableNames: 'idSeq'!

PQJsonRPCReq class
	instanceVariableNames: 'idSeq'!

!PQJsonRPCReq class methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/21/2014 12:17'!
initialize
	super initialize.
	idSeq := 1.! !

!PQJsonRPCReq class methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/21/2014 12:19'!
nextId
	"returns a new Id"
	
	idSeq := idSeq + 1.
	^ idSeq.! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:29'!
id
	^ id! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:29'!
id: anObject
	id := anObject! !

!PQJsonRPCReq methodsFor: 'initialization' stamp: 'PhilippeQuesnel 3/22/2014 00:58'!
initialize
	super initialize.
	"jsonrpc := '2.0'."	"note: golang jsonrpc is NOT 2.0 !!"
	id := self class nextId.! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
jsonrpc
	^ jsonrpc! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
jsonrpc: anObject
	jsonrpc := anObject! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
method
	^ method! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
method: anObject
	method := anObject! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
params
	^ params! !

!PQJsonRPCReq methodsFor: 'accessing' stamp: 'PhilippeQuesnel 3/21/2014 12:30'!
params: anObject
	params := anObject! !

Object subclass: #TestJsonRPC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PQTestJsonRPC'!

!TestJsonRPC methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/22/2014 23:15'!
createArithReq
	| req args |
	"create ArithArg parameter for Arith.Multiply"
	args := ArithArg new.
	args a: 20.
	args b: 21.
	
	"prepare jsonrpc request object"
	req := PQJsonRPCReq new.
	req method: 'Arith.Multiply'.
	req params: {args}. "golang jsonrpc is ver 1, needs to be array"

	"create json representation (neojson)"	
	^ String
		streamContents: [ :stream | 
			(NeoJSONWriter on: stream)
				mapInstVarsFor: PQJsonRPCReq;
				mapInstVarsFor: ArithArg;
				nextPut: req ]! !

!TestJsonRPC methodsFor: 'as yet unclassified' stamp: 'PhilippeQuesnel 3/22/2014 00:10'!
sendJsonRpcArith
	"comment stating purpose of message"

	| socket arithReq resp |
	socket := Socket newTCP.
	
	"send request"
	arithReq := self createArithReq.
	socket connectTo: NetNameResolver localHostAddress port: 8222.
	socket waitForConnectionFor: 1.
	
	socket sendData: arithReq.

	"read response"
	resp := socket receiveData.
	Transcript show: 'response is : '; show: resp; cr.

	socket closeAndDestroy.
! !
PQJsonRPCReq initialize!
